# SoVRMLBox Class Reference
[VRML97 classes]

`#include <Inventor/VRMLnodes/SoVRMLBox.h>`

Inheritance diagram for SoVRMLBox:

List of all members.

## Detailed Description

The SoVRMLBox class is used for representing a 3D box.

The detailed class documentation is taken verbatim from the VRML97 standard (ISO/IEC 14772-1:1997). It is copyright The Web3D Consortium, and is used by permission of the Consortium:

      Box {
        field    SFVec3f size  2 2 2        # (0, inf)
      }

The Box node specifies a rectangular parallelepiped box centred at (0, 0, 0) in the local coordinate system and aligned with the local coordinate axes. By default, the box measures 2 units in each dimension, from -1 to +1. The size field specifies the extents of the box along the X-, Y-, and Z-axes respectively and each component value shall be greater than zero. Figure 6.2 illustrates the Box node.

Figure 6.2

Textures are applied individually to each face of the box. On the front (+Z), back (-Z), right (+X), and left (-X) faces of the box, when viewed from the outside with the +Y-axis up, the texture is mapped onto each face with the same orientation as if the image were displayed normally in 2D. On the top face of the box (+Y), when viewed from above and looking down the Y-axis toward the origin with the -Z-axis as the view up direction, the texture is mapped onto the face with the same orientation as if the image were displayed normally in 2D. On the bottom face of the box (-Y), when viewed from below looking up the Y-axis toward the origin with the +Z-axis as the view up direction, the texture is mapped onto the face with the same orientation as if the image were displayed normally in 2D. SoVRMLTextureTransform affects the texture coordinates of the Box. The Box node's geometry requires outside faces only. When viewed from the inside the results are undefined.

## Public Member Functions

| SoVRMLBox (void)
virtual void | GLRender (SoGLRenderAction *action)
virtual void | rayPick (SoRayPickAction *action)
virtual void | getPrimitiveCount (SoGetPrimitiveCountAction *action)

## Static Public Member Functions

void | initClass (void)

## Public Attributes

SoSFVec3f | size

## Protected Member Functions

virtual | ~SoVRMLBox ()
virtual void | generatePrimitives (SoAction *action)
virtual void | computeBBox (SoAction *action, SbBox3f &box, SbVec3f &center)

## Constructor & Destructor Documentation

SoVRMLBox::SoVRMLBox | ( | void |  | ) |

| Constructor.

SoVRMLBox::~SoVRMLBox | ( |  | ) | `[protected, virtual]`

| Destructor.

## Member Function Documentation

void SoVRMLBox::initClass | ( | void |  | ) | `[static]`

| Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system. Reimplemented from SoVRMLGeometry.

void SoVRMLBox::GLRender | ( | SoGLRenderAction * | action | ) | `[virtual]`

| Action method for the SoGLRenderAction. This is called during rendering traversals. Nodes influencing the rendering state in any way or who wants to throw geometry primitives at OpenGL overrides this method. Reimplemented from SoShape.

void SoVRMLBox::rayPick | ( | SoRayPickAction * | action | ) | `[virtual]`

| Calculates picked point based on primitives generated by subclasses. Reimplemented from SoShape.

void SoVRMLBox::getPrimitiveCount | ( | SoGetPrimitiveCountAction * | action | ) | `[virtual]`

| Action method for the SoGetPrimitiveCountAction. Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action. Nodes influencing how geometry nodes calculates their primitive count also overrides this method to change the relevant state variables. Reimplemented from SoShape.

void SoVRMLBox::generatePrimitives | ( | SoAction * | action | ) | `[protected, virtual]`

The method implements action behavior for shape nodes for SoCallbackAction. It is invoked from SoShape::callback(). (Subclasses should not override SoNode::callback().)

The subclass implementations uses the convenience methods SoShape::beginShape(), SoShape::shapeVertex(), and SoShape::endShape(), with SoDetail instances, to pass the primitives making up the shape back to the caller.

Implements SoShape.

void SoVRMLBox::computeBBox | ( | SoAction * | action,
|  | SbBox3f & | box,
|  | SbVec3f & | center
| ) | `[protected, virtual]`

Implemented by SoShape subclasses to let the SoShape superclass know the exact size and weighted center point of the shape's bounding box.

The bounding box and center point should be calculated and returned in the local coordinate system.

The method implements action behavior for shape nodes for SoGetBoundingBoxAction. It is invoked from SoShape::getBoundingBox(). (Subclasses should not override SoNode::getBoundingBox().)

The box parameter sent in is guaranteed to be an empty box, while center is undefined upon function entry.

Implements SoShape.

## Member Data Documentation

SoVRMLBox::size

| Box size vector. Default value is (2,2,2).

The documentation for this class was generated from the following files:

- SoVRMLBox.h
- Box.cpp